# cin_seff

## Description
CINECA version of Slurm job efficiency report (seff).

`cin_seff` takes a list of jobids and reports on the efficiency of their cpu and memory utilization. 

### Example:

```bash
$ python3 cin_seff -j 863428[0-2]

Job ID:  8634280
User:    lbellen1
Account: cin_staff
State: CANCELLED by 33678 (exit code 0)
Nodes: 0

Job ID:  8634281
User:    amarani0
Account: cin_staff
State: COMPLETED (exit code 0)
Nodes: 20
Cores per node: 32
CPU Utilized: 1-02:09:06
CPU Efficiency: 12.37% of 8-19:22:40.0 core-walltime
Job Wall-clock time: 00:19:49
Memory Utilized: 235.4144630432129 GiB
Memory Efficiency: 19.57% of 1203.125 GiB


Job ID:  8634282
User:    amarani0
Account: cin_staff
State: COMPLETED (exit code 0)
Nodes: 20
Cores per node: 32
CPU Utilized: 1-02:17:56
CPU Efficiency: 12.38% of 8-20:26:40.0 core-walltime
Job Wall-clock time: 00:19:55
Memory Utilized: 235.4281005859375 GiB
Memory Efficiency: 19.57% of 1203.125 GiB
```

## Known Issue
Jobs executed in exclusive mode, where the requested resources do not fully occupy the entire node, may incorrectly report memory efficiency. For example, job 8754360 requested 15,400MB of memory but used 139,841,548KB, resulting in a reported memory efficiency of 886.78%.

## Credits
Based on [seff](https://github.com/SchedMD/slurm/blob/master/contribs/seff/seff) command, developed by Princeton University Research Computing.
